% pdist for large data  
% written by dengxin

function [dist_m] = pdist2_large(q_fet, set_fet, kernel_name)

    img_num = size(q_fet,1);
    
    dist_m = zeros(img_num, img_num);  
    
    range = 200;   % to avoid out-of-memory 
   
    if img_num>range 
       
        iter_num = floor(img_num/range);
        for ii=1:iter_num
            q_ind = 1+(ii-1)*range : ii*range;       
            D_ii =  pdist2(q_fet(q_ind,:),  set_fet, kernel_name); 
            dist_m(q_ind,:) = D_ii;
        end

        if ii*range<img_num
            q_ind = ii*range+1:img_num; 
          
            D_ii =  pdist2(q_fet(q_ind,:),  set_fet, kernel_name); 
            dist_m(q_ind,:) = D_ii;
        end 
        
    else 
        
         dist_m = pdist2(q_fet,  set_fet, kernel_name); 

    end
 

end
